##
##  antlr.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2023 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_antlr          4.13.1
%define       V_antlrworks     1.5

#   package information
Name:         antlr
Summary:      ANother Tool for Language Recognition (ANTLR)
URL:          http://www.antlr.org/
Vendor:       Terence Parr
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        PLUS
Group:        CompilerCompiler
License:      GPL
Version:      %{V_antlr}
Release:      20230905

#   list of sources
Source0:      http://www.antlr.org/download/antlr-%{V_antlr}-complete.jar
Source1:      http://www.antlr.org/download/antlrworks-%{V_antlrworks}.jar
Source2:      antlr.sh
Source3:      antlrworks.sh

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101, java, JAVA-JDK

%description
    ANother Tool for Language Recognition (ANTLR, formerly PCCTS)
    is a language tool that provides a framework for constructing
    recognizers, compilers, and translators from grammatical
    descriptions containing Java, C#, Python, or C++ actions. ANTLR
    is popular because it is easy to understand, powerful, flexible,
    generates human-readable output, and comes with complete source.
    ANTLR provides excellent support for tree construction, tree
    walking, and translation.

%track
    prog antlr = {
        version   = %{V_antlr}
        url       = http://www.antlr.org/download.html
        regex     = antlr-(\d+\.\d+(?:\.\d+)?)-complete\.jar
    }
    prog antlr:antrlworks = {
        version   = %{V_antlrworks}
        url       = http://www.antlr.org/download.html
        regex     = antlrworks-(__VER__)\.jar
    }

%prep
    %setup -q -T -c

%build

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/antlr
    %{l_shtool} install -c -m 644 \
        %{SOURCE antlr-%{V_antlr}-complete.jar} \
        %{SOURCE antlrworks-%{V_antlrworks}.jar} \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/antlr/
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE antlr.sh} $RPM_BUILD_ROOT%{l_prefix}/bin/antlr
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE antlrworks.sh} $RPM_BUILD_ROOT%{l_prefix}/bin/antlrworks
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

